# 
# Copyright (C) 1996-2001 LAAS/CNRS 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#    - Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
# $LAAS$
#----------------------------------------------------------------------
###
### Modele de l'environnement
###
### Ca peut etre produit automatiquement a partir des fichiers de MP
###

array set station_vertices { \
				 0 { 0.75 -1.3 } \
				 1 { 0.75 -2.3 } \
				 2 { 2.25 -2.3 } \
				 3 { 2.25 -1.3 } \
				 4 { 0.75 -2.5 } \
				 5 { 0.75 -3.5 } \
				 6 { 2.25 -3.5 } \
				 7 { 2.25 -2.5 } \
				 8 { 4.50 0.2 } \
				 9 { 4.50 -0.8 } \
				 10 { 6.00 -0.8 } \
				 11 { 6.00 0.2 } \
				 12 { -2.50 -12.40 } \
				 13 { -2.50 -13.40 } \
				 14 { -1.00 -13.40 } \
				 15 { -1.0 -12.40 } \
				 16 { -2.50 -4.87 } \
				 17 { -2.50 -5.87 } \
				 18 { -1.0 -5.87 } \
				 19 { -1.0 -4.87 } \
				 20 { 8.90 -13.25 } \
				 21 { 8.90 -14.75 } \
				 22 { 9.90 -14.75 } \
				 23 { 9.90 -13.25 } \
				 24 { 6.0 -7.60 } \
				 25 { 6.0 -8.60 } \
				 26 { 7.50 -8.60 } \
				 27 { 7.50 -7.60 } \
			     }

array set station_boundaries { \
				   0 { 4 0 1 2 3 } \
				   1 { 4 4 5 6 7 } \
				   2 { 4 8 9 10 11 } \
				   3 { 4 16 17 18 19 } \
				   4 { 4 12 13 14 15 } \
				   5 { 4 20 21 22 23 } \
				   6 { 4 24 25 26 27 } \
			       }

array set cell_vertices { \
			      0 { -2.60 -11.90 } \
			      1 { 8.60 -11.90 } \
			      2 { 8.60 -6.00 } \
			      3 { 6.40 -6.00 } \
			      4 { 6.40 -3.00 } \
			      5 { 6.40 0.60 } \
			      6 { -2.60 0.60 } \
			      7 { 11.40 0.60 } \
			      8 { 11.40 -10.00 } \
			      9 { 10.00 -10.00 } \
			      10 { 10.00 -11.90 } \
			      11 { 10.00 -8.0 } \
			      12 { 10.00 -3.00 } \
			      13 { 11.40 -11.90 } \
			      14 { 11.40 -15.00 } \
			      15 { 7.40 -15.00 } \
			      16 { 7.40 -13.90 } \
			      17 { -2.60 -13.90 } \
			      18 { 11.40 -8.00 } \
			      19 { 8.60 -8.00 } \
			      20 { 11.40 -3.00 }\
			  }

array set cell_boundaries { \
				0 { 7 0 1 2 3 4 5 6 } \
				1 { 13 0 17 16 15 14 13 10 9 8 18 11 19 1 } \
				2 { 4 4 3 2 12 } \
				3 { 5 5 4 12 20 7 } \
				4 { 4 12 11 18 20 } \
				5 { 4 12 2 19 11 } \
			    }


array set obstacle_vertices { \
				  0 { -2.60 -9.00 } \
				  1 { -2.60 -6.0 } \
				  2 { 2.00 -6.0 } \
				  3 { 2.00 -9.00 } \
				  4 { 6.40 -0.60 } \
				  5 { 6.40 0.60 } \
				  6 { 7.20 0.60 } \
				  7 { 7.20 -0.60 } \
				  8 { -2.60 -4.75 } \
				  9 { -2.60 -4.35  } \
				  10 { 1.0 -4.35 } \
				  11 { 1.0 -4.75 } \
				  12 { 0.0 -4.20 } \
				  13 { 0.0 0.20 }\
				  14 { 0.40 0.20 } \
				  15 { 0.40 -4.20 } \
				  16 { 2.80 -11.00 } \
				  17 { 2.80 -6.80 } \
				  18 { 4.0 -6.80 } \
				  19 { 4.0 -7.60 } \
				  20 { 4.50 -7.60 } \
				  21 { 4.50 -11.00 } \
				  22 { 5.70 -6.90 } \
				  23 { 5.70 -6.00 } \
				  24 { 8.60 -6.0 } \
				  25 { 8.60 -11.00 } \
				  26 { 8.20 -11.00 } \
				  27 { 8.20 -6.90 } \
				  28 { 1.20 0.60 } \
				  29 { 1.60 0.60 } \
				  30 { 1.60 -0.20 } \
				  31 { 1.20 -0.20 } \
				  32 { 7.20 0.60 } \
				  33 { 11.40 0.60 } \
				  34 { 11.40 -0.20 } \
				  35 { 7.20 -0.20 } \
				  36 { -2.60 -11.50 } \
				  37 { 8.60 -11.50 } \
				  38 { 8.60 -11.90 } \
				  39 { -2.60 -11.90 } \
				  40 { 10.00 -10.00 } \
				  41 { 11.40 -10.00 } \
				  42 { 11.40 -11.90 } \
				  43 { 10.00 -11.90 } \
			      }
array set obstacle_boundaries {  \
				      0 {4 0 1 2 3} \
				      1 {4 4 5 6 7}\
				      2 {4 8 9 10 11}\
				      3 {4 12 13 14 15} \
				      4 {6 16 17 18 19 20 21}\
				      5 {6 24 25 26 27 22 23}\
				      6 {4 28 29 30 31}\
				      7 {4 32 33 34 35}\
				      8 {4 36 37 38 39}\
				      9 {4 40 41 42 43}\
				  }

# dimensions
set xmin -5
set xmax 10
set ymin -15
set ymax 0
set zmin 0
set zmax 2.0

# point de vue initial
set obsDist 5
set obsAzi -90
set obsElev 20
set obsX 2
set obsY -4
set obsZ 0.8


# signale qu'un modele d'environnement est defini
set envDefined True
