# 
# Copyright (C) 1996-2001 LAAS/CNRS 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#    - Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
# $LAAS$
#----------------------------------------------------------------------
###
### Modele de la plate-forme remorque
###



proc trailerGeometry { } {

    cullFace True
    object trailer {
	color 220 220 220
	#plateforme
	box .0 .0 .17 .6 .46 .015

	color 0 80 50
	#roues
	cylinder 0.0 0.25 0.15 y 0.30 0.05
	cylinder 0.0 -0.30 0.15 y 0.30 0.05

	color 80 80 80
	
	# axe des roues
	cylinder 0.0 -0.302 0.15 y 0.04 0.604

	#attache
	cylinder 0.0 0 0.14 x 0.04 0.69
	color 240 240 240 
	cylinder .69 0 0.14 x 0.04 0.04

	color 150 150 150
	# flasques des roues 
	cylinder 0.0 0.249 0.15 y 0.25 0.052
	cylinder 0.0 -0.301 0.15 y 0.25 0.052


	color 30 30 30 
	# bumper
	prism 4 0.0 0.0 0.06 \
	    .35 -.23 .17\
	    .35 .23 .17 \
	    .31 .23 .17 \
	    .31 -.23 .17

	prism 4 0.0 0.0 0.06\
	    .35 .23 .17 \
	    .23 .35 .17 \
	    .23 .31 .17 \
	    .31 .23 .17 

	prism 4 0.0 0.0 0.06 \
	    .23 .35 .17 \
	    -.23 .35 .17 \
	    -.23 .31 .17 \
	    .23 .31 .17 

	prism 4 0.0 0.0 0.06 \
	    -.23 .35 .17 \
	    -.35 .23 .17 \
	    -.31 .23 .17 \
	    -.23 .31 .17

	prism 4 0.0 0.0 0.06 \
	     -.35 .23 .17 \
	    -.35 -.23 .17 \
	    -.31 -.23 .17 \
	    -.31 .23 .17

	prism 4 0.0 0.0 0.06 \
	    -.35 -.23 .17 \
	    -.23 -.35 .17 \
	    -.23 -.31 .17 \
	    -.31 -.23 .17

	prism 4 0.0 0.0 0.06 \
	    -.23 -.35 .17 \
	    .23 -.35 .17 \
	    .23 -.31 .17 \
	    -.23 -.31 .17
	
	prism 4 0.0 0.0 0.06 \
	    .23 -.35 .17 \
	    .35 -.23 .17 \
	    .31 -.23 .17 \
	    .23 -.31 .17

	# sick
	color 20 20 220
	box  -0.175 0.0 0.55  0.15 0.15 0.07
	box  -0.125 0.0 0.47  0.05 0.15 0.08
	box  -0.175 0.0 0.46  0.15 0.15 0.02
	color 20 20 20
	box  -0.190 0.0 0.47  0.08 0.10 0.08
	color 150 150 20
	box  -0.125 0.085 0.145 0.04 0.02 0.35
	box  -0.125 -0.085 0.145 0.04 0.02 0.35
    }
}

proc trailerGeometryc { } {

    cullFace True
    object trailer {
	color 200 0 0
	#plateforme
	box .0 .0 .17 .6 .46 .015

	color 200 0 0
	#roues
	cylinder 0.0 0.25 0.15 y 0.30 0.05
	cylinder 0.0 -0.30 0.15 y 0.30 0.05

	color 200 0 0
	
	# axe des roues
	cylinder 0.0 -0.302 0.15 y 0.04 0.604

	#attache
	cylinder 0.0 0 0.14 x 0.04 0.69
	color 200 0 0
	cylinder .69 0 0.14 x 0.04 0.04

	color 200 0 0
	# flasques des roues 
	cylinder 0.0 0.249 0.15 y 0.25 0.052
	cylinder 0.0 -0.301 0.15 y 0.25 0.052


	color 200 0 0
	# bumper
	prism 4 0.0 0.0 0.06 \
	    .35 -.23 .17\
	    .35 .23 .17 \
	    .31 .23 .17 \
	    .31 -.23 .17

	prism 4 0.0 0.0 0.06\
	    .35 .23 .17 \
	    .23 .35 .17 \
	    .23 .31 .17 \
	    .31 .23 .17 

	prism 4 0.0 0.0 0.06 \
	    .23 .35 .17 \
	    -.23 .35 .17 \
	    -.23 .31 .17 \
	    .23 .31 .17 

	prism 4 0.0 0.0 0.06 \
	    -.23 .35 .17 \
	    -.35 .23 .17 \
	    -.31 .23 .17 \
	    -.23 .31 .17

	prism 4 0.0 0.0 0.06 \
	     -.35 .23 .17 \
	    -.35 -.23 .17 \
	    -.31 -.23 .17 \
	    -.31 .23 .17

	prism 4 0.0 0.0 0.06 \
	    -.35 -.23 .17 \
	    -.23 -.35 .17 \
	    -.23 -.31 .17 \
	    -.31 -.23 .17

	prism 4 0.0 0.0 0.06 \
	    -.23 -.35 .17 \
	    .23 -.35 .17 \
	    .23 -.31 .17 \
	    -.23 -.31 .17
	
	prism 4 0.0 0.0 0.06 \
	    .23 -.35 .17 \
	    .35 -.23 .17 \
	    .31 -.23 .17 \
	    .23 -.31 .17

	# sick
	color 200 0 0
	box  -0.175 0.0 0.55  0.15 0.15 0.07
	box  -0.125 0.0 0.47  0.05 0.15 0.08
	box  -0.175 0.0 0.46  0.15 0.15 0.02
	color 200 0 0
	box  -0.190 0.0 0.47  0.08 0.10 0.08
	color 200 0 0
	box  -0.125 0.085 0.145 0.04 0.02 0.35
	box  -0.125 -0.085 0.145 0.04 0.02 0.35
    }
}

proc trailer phi {
    global trailerPosLink remorquePosCentre 
    set trailerPosLink -0.65
    set trailerPosCentre -1.40

    pushMatrix
    translate  $trailerPosLink 0 0 
    rotate $phi 0 0 1
    translate [expr $trailerPosCentre - $trailerPosLink] 0 0
    trailerGeometry
    popMatrix
}

proc trailerc phi {
    global trailerPosLink remorquePosCentre 
    set trailerPosLink -0.65
    set trailerPosCentre -1.40

    pushMatrix
    translate  $trailerPosLink 0 0 
    rotate $phi 0 0 1
    translate [expr $trailerPosCentre - $trailerPosLink] 0 0
    trailerGeometryc
    popMatrix
}
proc trailerAndArm {phi q1 q2 q3 q4 q5 q6 } {
    global trailerPosLink remorquePosCentre 
    global armPosX armPosY armPosZ armPosTheta

    set trailerPosLink -0.65
    set trailerPosCentre -1.55

    pushMatrix
    translate  $trailerPosLink 0 0 
    rotate $phi 0 0 1
    translate [expr $trailerPosCentre - $trailerPosLink] 0 0
    trailerGeometry
    popMatrix

    pushMatrix
    translate $armPosX $armPosY $armPosZ
    rotate $armPosTheta 0 0 1
    arm1 $q1 $q2 $q3 $q4 $q5 $q6
    popMatrix    
}
